local options = {
	type = "group",
	args = {
		config = {
			type = "execute",
			name = "Configure",
			order = 1,
			desc = "Open the Configuration Dialog",
			func = function() ZThreatMeter:ShowConfig() end,
			guiHidden = true
		},
		reset = {
			type = "execute",
			name = "reset",
			order = 2,
			desc = "Reset the frame position and scale",
			func = function() ZThreatMeter.frame:SetPoint("CENTER", UIParent, "CENTER", 0, 0) ZThreatMeter.frame:SetScale(1) ZThreatMeter.frame:Show(); end,
			guiHidden = true
		},
		settings = {
			type = "group",
			name = "Settings",
			order = 3,
			desc = "General Settings",
			args = {
                empty1 = {
                    type = "header",
                    order = 1,
                    cmdHidden = true,
                    dropdownHidden = true,
                    name = "General Settings",
                },
				raw = {
					type = "toggle",
					name = "Show raw percent",
					width = "full",
					desc = "Show the raw threat percent value instead of the scaled value.",
					order = 2,
					get = function (info)
							if (ZThreatMeter.db.profile.tvalue == "rP") then
								return true
							else
								return false
							end
						  end,
					set = function (info)
							if (ZThreatMeter.db.profile.tvalue == "rP") then
								ZThreatMeter.db.profile.tvalue = "sP"
								return false
							else
								ZThreatMeter.db.profile.tvalue = "rP"
								return true
							end
						 end,
				},
               empty2 = {
                    type = "header",
                    order = 3,
                    cmdHidden = true,
                    dropdownHidden = true,
                    name = "Bar Settings",
                },
				showself = {
					type = "toggle",
					name = "Force my bar",
					width = "full",
					desc = "Always show my own bar regardless of threat value.",
					order = 4,
					get = function (info) return ZThreatMeter.db.profile.showself end,
					set = function (info) ZThreatMeter.db.profile.showself = not ZThreatMeter.db.profile.showself end,
				},
				colorself = {
					type = "toggle",
					name = "Color my bar",
					width = "full",
					desc = "Show my own bar in red.",
					order = 5,
					get = function (info) return ZThreatMeter.db.profile.colorself end,
					set = function (info) ZThreatMeter.db.profile.colorself = not ZThreatMeter.db.profile.colorself end,
				},
				showpets = {
					type = "toggle",
					name = "Show pets",
					desc = "Show pet bars.",
					order = 6,
					get = function (info)
							if (ZThreatMeter.db.profile.showpets) then
								ZThreatMeter.options.args.settings.args.showpetsolo.disabled = false;
							end
							return ZThreatMeter.db.profile.showpets
						  end,
					set = function (info)
						  	ZThreatMeter.db.profile.showpets = not ZThreatMeter.db.profile.showpets ;
							if (ZThreatMeter.db.profile.showpets) then
								ZThreatMeter.options.args.settings.args.showpetsolo.disabled = false;
							else
								ZThreatMeter.options.args.settings.args.showpetsolo.disabled = true;
							end
						  end,
				},
				showpetsolo = {
					type = "toggle",
					name = "Only when solo",
					desc = "Show pets only when solo.",
					disabled = true,
					order = 7,
					get = function (info) return ZThreatMeter.db.profile.showpetssolo end,
					set = function (info) ZThreatMeter.db.profile.showpetssolo = not ZThreatMeter.db.profile.showpetssolo end,
				},
				limit = {
					type = "range",
					name = "Max. Bars",
					desc = "Maximum number of bars to show.",
					order = 8,
					min = 1,
					max = 40,
					step = 1,
					get = function() return ZThreatMeter.db.profile.limit end,
					set = function(info, v) ZThreatMeter.db.profile.limit = v end,
				},
                dsc = {
                    type = "description",
                    order = 9,
                    cmdHidden = true,
                    dropdownHidden = true,
                    name = " "
                },
                empty3 = {
                    type = "header",
                    order = 10,
                    cmdHidden = true,
                    dropdownHidden = true,
                    name = "Visibility Settings",
                },
                solo = {
                    type = "toggle",
                    name = "Solo",
                    width = "full",
                    desc = "Addon is enabled when solo.",
                    order = 11,
                    get = function(info) return ZThreatMeter.db.profile.frame.solo end,
                    set = function(info) ZThreatMeter.db.profile.frame.solo = not ZThreatMeter.db.profile.frame.solo ZThreatMeter:SetFrameVisibility() end
                },
                party = {
                    type = "toggle",
                    name = "Party",
                    width = "full",
                    desc = "Addon is enabled in partys.",
                    order = 12,
                    get = function(info) return ZThreatMeter.db.profile.frame.party end,
                    set = function(info) ZThreatMeter.db.profile.frame.party = not ZThreatMeter.db.profile.frame.party ZThreatMeter:SetFrameVisibility() end
                },
                raid = {
                    type = "toggle",
                    name = "Raid",
                    width = "full",
                    desc = "Addon is enabled in raids.",
                    order = 13,
                    get = function(info) return ZThreatMeter.db.profile.frame.raid end,
                    set = function(info) ZThreatMeter.db.profile.frame.raid = not ZThreatMeter.db.profile.frame.raid ZThreatMeter:SetFrameVisibility() end
                },
			},
		},
		frame = {
			type = "group",
			name = "Frame",
			order = 4,
			desc = "Frame Settings",
			args = {
				scale = {
					type = "range",
					name = "UI Scale",
					desc = "Scales the UI to a factor of the default.",
					order = 1,
					min = 0.1,
					max = 5,
					step = 0.05,
					get = function(info) return ZThreatMeter.db.profile.frame.scale end,
					set = function(info, v) ZThreatMeter.db.profile.frame.scale = v; ZThreatMeter:UpdateScale(); end
				},
			},
		},
	},
}

function ZThreatMeter:ShowConfig()
	LibStub("AceConfigDialog-3.0"):Open("ZThreatMeter", nil)
end

LibStub("AceConfig-3.0"):RegisterOptionsTable("ZThreatMeter", options, {"ZThreatMeter", "zt"})
ZThreatMeter.options = options;